pcl::MomentInvariantsEstimation< PointInT, PointOutT > Class Template Reference
Module features

MomentInvariantsEstimation estimates the 3 moment invariants (j1, j2, j3) at each 3D point. More...

`#include <pcl/features/moment_invariants.h>`

Inheritance diagram for pcl::MomentInvariantsEstimation< PointInT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< MomentInvariantsEstimation< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const MomentInvariantsEstimation< PointInT, PointOutT > >
using | PointCloudOut = typename Feature< PointInT, PointOutT >::PointCloudOut
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, std::vector< int > &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, std::vector< int > &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| MomentInvariantsEstimation ()
| Empty constructor. More...
void | computePointMomentInvariants (const pcl::PointCloud< PointInT > &cloud, const std::vector< int > &indices, float &j1, float &j2, float &j3)
| Compute the 3 moment invariants (j1, j2, j3) for a given set of points, using their indices. More...
void | computePointMomentInvariants (const pcl::PointCloud< PointInT > &cloud, float &j1, float &j2, float &j3)
| Compute the 3 moment invariants (j1, j2, j3) for a given set of points, using their indices. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Estimate moment invariants for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT>
class pcl::MomentInvariantsEstimation< PointInT, PointOutT >

MomentInvariantsEstimation estimates the 3 moment invariants (j1, j2, j3) at each 3D point.

Note
  The code is stateful as we do not expect this class to be multicore parallelized. Please look at NormalEstimationOMP for an example on how to extend this to parallel implementations.

Author
  Radu B. Rusu

Definition at line 55 of file moment_invariants.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointOutT >

using pcl::MomentInvariantsEstimation< PointInT, PointOutT >::ConstPtr = shared_ptr<const MomentInvariantsEstimation<PointInT, PointOutT> >

Definition at line 59 of file moment_invariants.h.

## PointCloudOut

template<typename PointInT , typename PointOutT >

using pcl::MomentInvariantsEstimation< PointInT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 68 of file moment_invariants.h.

## Ptr

template<typename PointInT , typename PointOutT >

using pcl::MomentInvariantsEstimation< PointInT, PointOutT >::Ptr = shared_ptr<MomentInvariantsEstimation<PointInT, PointOutT> >

Definition at line 58 of file moment_invariants.h.

## Constructor & Destructor Documentation

## MomentInvariantsEstimation()

template<typename PointInT , typename PointOutT >

pcl::MomentInvariantsEstimation< PointInT, PointOutT >::MomentInvariantsEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 71 of file moment_invariants.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## computeFeature()

template<typename PointInT , typename PointOutT >

void pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Estimate moment invariants for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  [out] | output | the resultant point cloud model dataset that contains the moment invariants

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 116 of file moment_invariants.hpp.

References pcl::PointCloud< PointT >::is_dense, pcl::isFinite(), and pcl::PointCloud< PointT >::points.

## computePointMomentInvariants() [1/2]

template<typename PointInT , typename PointOutT >

void pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computePointMomentInvariants | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | const std::vector< int > & | indices,
|  | float & | j1,
|  | float & | j2,
|  | float & | j3
| ) |  |

Compute the 3 moment invariants (j1, j2, j3) for a given set of points, using their indices.

Parameters

  [in] | cloud | the input point cloud
  [in] | indices | the point cloud indices that need to be used
  [out] | j1 | the resultant first moment invariant
  [out] | j2 | the resultant second moment invariant
  [out] | j3 | the resultant third moment invariant

Definition at line 49 of file moment_invariants.hpp.

References pcl::compute3DCentroid(), and pcl::PointCloud< PointT >::points.

## computePointMomentInvariants() [2/2]

template<typename PointInT , typename PointOutT >

void pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computePointMomentInvariants | ( | const pcl::PointCloud< PointInT > & | cloud,
|  | float & | j1,
|  | float & | j2,
|  | float & | j3
| ) |  |

Compute the 3 moment invariants (j1, j2, j3) for a given set of points, using their indices.

Parameters

  [in] | cloud | the input point cloud
  [out] | j1 | the resultant first moment invariant
  [out] | j2 | the resultant second moment invariant
  [out] | j3 | the resultant third moment invariant

Definition at line 83 of file moment_invariants.hpp.

References pcl::compute3DCentroid(), and pcl::PointCloud< PointT >::points.

The documentation for this class was generated from the following files:

- pcl/features/moment_invariants.h
- pcl/features/impl/moment_invariants.hpp